<script setup lang="ts">
import type { BaseLink } from '@/types/base';
import { ChevronLgRight, PlayCircle } from 'slippers-ui/icons';
import { ref } from 'vue';
import GradientStarEyebrow from '~/assets/icons/gradient-star-eyebrow.vue';

interface VideoCardProps {
  header: string;
  text: string;
  eyebrow: string;
  link: BaseLink;
  video: {
    config?: {
      thumbnail?: string;
      src: string;
    };
  };
  config: {
    theme?: string;
  };
}

defineProps<VideoCardProps>();
const modalOpen = ref(false);
const openModal = () => {
  modalOpen.value = true;
};
const closeModal = () => {
  modalOpen.value = false;
};
</script>

<template>
  <section class="slp-py-96 video-card" :class="`video-card--${config?.theme}`">
    <SlpContainer>
      <SlpRow class="container">
        <article class="video-card__highlight">
          <SlpColumn :cols="6" class="video-card__content">
            <div class="video-card__eyebrow">
              <GradientStarEyebrow class="img" />
              <SlpTypography variant="body2-bold" tag="span">
                {{ eyebrow }}
              </SlpTypography>
            </div>
            <div class="video-card__flex">
              <div class="video-card__header">
                <SlpTypography tag="h3" variant="heading4-bold">
                  {{ header }}
                </SlpTypography>
                <GradientStarEyebrow class="img" />
              </div>

              <SlpTypography v-if="text" variant="body1" tag="div" class="video-card__text">
                <div v-html="$md.render(text)" />
              </SlpTypography>

              <SlpButton
                variant="tertiary"
                :href="link.config.href"
                :data-ga-name="link.config.dataGaName"
                :data-ga-location="link.config.dataGaLocation"
              >
                {{ link.text }}
                <SlpIcon :icon="ChevronLgRight" />
              </SlpButton>
            </div>
          </SlpColumn>
          <div class="video-card__media-container" @click="openModal()">
            <SlpIcon :icon="PlayCircle" size="xl" class="video-card__play-icon slp-mr-16" color="accent-400" />
            <img :src="video.config?.thumbnail" alt="" />
          </div>
        </article>
        <CommonVideoModal light-background :visible="modalOpen" @close="closeModal">
          <template #body>
            <CommonVideo :video-src="video.config?.src" />
          </template>
        </CommonVideoModal>
      </SlpRow>
    </SlpContainer>
  </section>
</template>

<style lang="scss" scoped>
.video-card {
  &__highlight {
    position: relative;
    flex: 1 0 100%;
    background: linear-gradient(0.71deg, rgba(225, 152, 109, 0.1) 0.61%, rgba(110, 67, 211, 0.1) 99.4%);
    border: 1px solid $color-surface-600;
    border-radius: 8px;
    display: flex;

    @media (max-width: $breakpoint-md) {
      flex-direction: column-reverse;
    }
  }
  &__content {
    padding: 32px;
    flex: 0 0 60%;
  }
  &__media-container {
    width: 100%;
    position: relative;

    @media (max-width: $breakpoint-md) {
      flex: 0 0 0;
    }

    img {
      width: 100%;
      height: 100%;
      display: block;
      cursor: pointer;
      object-fit: cover;
      object-position: center;
      border-radius: 0 8px 8px 0;

      @media (max-width: $breakpoint-md) {
        border-radius: 8px 8px 0 0;
      }
    }
  }
  &__play-icon {
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%);
    font-size: 48px;
    color: #171321;
    cursor: pointer;
    z-index: 2;
    path {
      fill: #fff;
      transition: fill 0.2s ease;
    }

    circle {
      transition: fill 0.2s ease;
    }
  }
  &__eyebrow {
    margin-bottom: 16px;
    position: relative;
    padding: 4px 12px;
    display: inline-flex;
    align-items: center;

    .img {
      width: 20px;
      height: 20px;
      margin-right: 5px;
    }

    &:before {
      content: '';
      position: absolute;
      top: 0;
      right: 0;
      bottom: 0;
      left: 0;
      border-radius: 20px;
      border: 1.5px solid transparent;
      background: linear-gradient(89.09deg, #e1986d -1.12%, #7759c2 102.06%, #6e43d3 102.07%) border-box;
      -webkit-mask:
        linear-gradient(#fff 0, #fff 0) padding-box,
        linear-gradient(#fff 0, #fff 0);
      -webkit-mask:
        linear-gradient(#fff 0 0) padding-box,
        linear-gradient(#fff 0 0);
      -webkit-mask-composite: xor;
      mask-composite: exclude;
    }
  }
  &__flex {
    display: flex;
    flex-direction: column;
    justify-content: space-between;
    gap: 24px;
  }
  &__text {
    margin-bottom: 24px;
    color: #a2a1a6 !important;
  }
  &__header {
    display: flex;
    gap: 8px;

    img {
      padding-bottom: 8px;
    }

    @media (max-width: $breakpoint-md) {
      h3 {
        flex: 0 0 70%;
      }
    }
  }
  &--dark {
    background-color: $color-primary-200;
    color: #fff;
    .slp-btn {
      color: #fff;
    }
  }
}
</style>
